import fasttint
import renpy_glue

class Database(list):
    def __init__(db, fn):
        f = renpy_glue.open_r(fn)
        #if use_renpy and not fn.starts:
        #    f = file(renpy_gamedir+fn,'rb')
        #else:
        #    f = file(fn)
        lines = f.readlines()
        db.encrypted = int(lines[0])
        db.tables = db.decrypt(int(lines[1]))
        if db.tables!=1:
            raise "Too many tables."
        # Not sure what lines[2] is for.
        # lines[3] is a comma-separated list: cols, rows
        cols,rows = lines[3].split(',')
        cols = int(cols)
        rows = int(rows)
        # 4 and 5 seem to be nothing in particular
        x = 6
        entries = []
        while x<len(lines):
            row = []
            entries.append(row)
            line = lines[x][3:]
            j = 3
            i = 2
            while i<=cols:
                la = line.split('{'+str(i)+'}')
                row.append(la[0])
                line = la[1]
                i += 1
            la = line.split('{'+str(i)+'}')
            row.append(la[0])
            x += 1
        db.entries = entries
    def decrypt(db,s):
        if not db.encrypted:
            return s
        else:
            raise "DB encryption not yet implimented."
class DatabaseCache(dict):
    def __getitem__(cache,key):
        if cache.has_key(key):
            return dict.__getitem__(cache,key)
        db = Database(key)
        cache[key] = db
        return db

database_cache = DatabaseCache()
def lookup_direct(file, table, column, row, change=None):
    if type(file) is fasttint.GMVar:
        file = file[0]
    db = database_cache[file]
    if table!=1:
        raise "Too many tables."
    if change is not None:
        db.entries[int(row)][int(column)] = change
    return db.entries[int(row)-1][int(column)-1]
