from distutils.core import setup, Extension

module1 = Extension('fasttint', sources=[
                'fasttint.c', 'rooms.c', 'common.c', 'flip.c'],
        include_dirs=['/usr/include/SDL'],
        extra_compile_args=['-flax-vector-conversions','-mmmx'],
        library_dirs=['/home/deekoo/SDL_gfx-2.0.20/.libs/',],
        libraries=['SDL','SDL_gfx',
            #'dmalloc'
            ],
        )
setup(name='FastTint',version='0.0',description='Fast Tinting', ext_modules=[module1])
