from distutils.core import setup, Extension

module1 = Extension('fasttint', sources=['flip.c','fasttint.c', 'rooms.c', 'common.c'],
        include_dirs=['/usr/include/SDL'],
        extra_compile_args=['-flax-vector-conversions','-mmmx'],
        libraries=['SDL','SDL_gfx',
            #'dmalloc'
            ],
        )
setup(name='FastTint',version='0.0',description='Fast Tinting', ext_modules=[module1])
