from distutils.core import setup, Extension

module1 = Extension('fasttint', sources=['fasttint.c'],
        include_dirs=['./renpy-deps/install/include/',
                './renpy-deps/install/include/SDL/',
                ],
        extra_compile_args=['-maltivec', ],
        library_dirs=['./renpy-deps/install/lib/',],
        libraries=['SDL','SDL_gfx',],
        )
setup(name='FastTint',version='0.0',description='Fast Tinting', ext_modules=[module1])
